// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TntIniFiles.pas' rev: 6.00

#ifndef TntIniFilesHPP
#define TntIniFilesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <TntWideStrings.hpp>	// Pascal unit
#include <TntClasses.hpp>	// Pascal unit
#include <IniFiles.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Tntinifiles
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TTntCustomIniFile;
class PASCALIMPLEMENTATION TTntCustomIniFile : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	WideString FFileName;
	
public:
	__fastcall TTntCustomIniFile(const WideString FileName);
	bool __fastcall SectionExists(const WideString Section);
	virtual WideString __fastcall ReadString(const WideString Section, const WideString Ident, const WideString Default) = 0 ;
	virtual void __fastcall WriteString(const WideString Section, const WideString Ident, const WideString Value) = 0 ;
	virtual int __fastcall ReadInteger(const WideString Section, const WideString Ident, int Default);
	virtual void __fastcall WriteInteger(const WideString Section, const WideString Ident, int Value);
	virtual bool __fastcall ReadBool(const WideString Section, const WideString Ident, bool Default);
	virtual void __fastcall WriteBool(const WideString Section, const WideString Ident, bool Value);
	virtual int __fastcall ReadBinaryStream(const WideString Section, const WideString Name, Classes::TStream* Value);
	virtual System::TDateTime __fastcall ReadDate(const WideString Section, const WideString Name, System::TDateTime Default);
	virtual System::TDateTime __fastcall ReadDateTime(const WideString Section, const WideString Name, System::TDateTime Default);
	virtual double __fastcall ReadFloat(const WideString Section, const WideString Name, double Default);
	virtual System::TDateTime __fastcall ReadTime(const WideString Section, const WideString Name, System::TDateTime Default);
	virtual void __fastcall WriteBinaryStream(const WideString Section, const WideString Name, Classes::TStream* Value);
	virtual void __fastcall WriteDate(const WideString Section, const WideString Name, System::TDateTime Value);
	virtual void __fastcall WriteDateTime(const WideString Section, const WideString Name, System::TDateTime Value);
	virtual void __fastcall WriteFloat(const WideString Section, const WideString Name, double Value);
	virtual void __fastcall WriteTime(const WideString Section, const WideString Name, System::TDateTime Value);
	virtual void __fastcall ReadSection(const WideString Section, Tntclasses::TTntStrings* Strings) = 0 ;
	virtual void __fastcall ReadSections(Tntclasses::TTntStrings* Strings) = 0 /* overload */;
	virtual void __fastcall ReadSections(const WideString Section, Tntclasses::TTntStrings* Strings)/* overload */;
	virtual void __fastcall ReadSectionValues(const WideString Section, Tntclasses::TTntStrings* Strings) = 0 ;
	virtual void __fastcall EraseSection(const WideString Section) = 0 ;
	virtual void __fastcall DeleteKey(const WideString Section, const WideString Ident) = 0 ;
	virtual void __fastcall UpdateFile(void) = 0 ;
	bool __fastcall ValueExists(const WideString Section, const WideString Ident);
	__property WideString FileName = {read=FFileName};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TTntCustomIniFile(void) { }
	#pragma option pop
	
};


struct TTntHashItem;
typedef TTntHashItem *PTntHashItem;

typedef PTntHashItem *PPTntHashItem;

#pragma pack(push, 4)
struct TTntHashItem
{
	TTntHashItem *Next;
	WideString Key;
	int Value;
} ;
#pragma pack(pop)

typedef DynamicArray<PTntHashItem >  TntIniFiles__3;

class DELPHICLASS TTntStringHash;
class PASCALIMPLEMENTATION TTntStringHash : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	DynamicArray<PTntHashItem >  Buckets;
	
protected:
	PPTntHashItem __fastcall Find(const WideString Key);
	virtual unsigned __fastcall HashOf(const WideString Key);
	
public:
	__fastcall TTntStringHash(unsigned Size);
	__fastcall virtual ~TTntStringHash(void);
	void __fastcall Add(const WideString Key, int Value);
	void __fastcall Clear(void);
	void __fastcall Remove(const WideString Key);
	bool __fastcall Modify(const WideString Key, int Value);
	int __fastcall ValueOf(const WideString Key);
};


class DELPHICLASS TTntHashedStringList;
class PASCALIMPLEMENTATION TTntHashedStringList : public Tntclasses::TTntStringList 
{
	typedef Tntclasses::TTntStringList inherited;
	
private:
	TTntStringHash* FValueHash;
	TTntStringHash* FNameHash;
	bool FValueHashValid;
	bool FNameHashValid;
	void __fastcall UpdateValueHash(void);
	void __fastcall UpdateNameHash(void);
	
protected:
	virtual void __fastcall Changed(void);
	
public:
	__fastcall virtual ~TTntHashedStringList(void);
	virtual int __fastcall IndexOf(const WideString S);
	virtual int __fastcall IndexOfName(const WideString Name);
public:
	#pragma option push -w-inl
	/* TTntStrings.Create */ inline __fastcall TTntHashedStringList(void) : Tntclasses::TTntStringList() { }
	#pragma option pop
	
};


class DELPHICLASS TTntMemIniFile;
class PASCALIMPLEMENTATION TTntMemIniFile : public TTntCustomIniFile 
{
	typedef TTntCustomIniFile inherited;
	
private:
	Tntclasses::TTntStringList* FSections;
	Tntclasses::TTntStrings* __fastcall AddSection(const WideString Section);
	bool __fastcall GetCaseSensitive(void);
	void __fastcall LoadValues(void);
	void __fastcall SetCaseSensitive(bool Value);
	
public:
	__fastcall virtual TTntMemIniFile(const WideString FileName);
	__fastcall virtual ~TTntMemIniFile(void);
	void __fastcall Clear(void);
	virtual void __fastcall DeleteKey(const WideString Section, const WideString Ident);
	virtual void __fastcall EraseSection(const WideString Section);
	void __fastcall GetStrings(Tntclasses::TTntStrings* List);
	virtual void __fastcall ReadSection(const WideString Section, Tntclasses::TTntStrings* Strings);
	virtual void __fastcall ReadSections(Tntclasses::TTntStrings* Strings)/* overload */;
	virtual void __fastcall ReadSectionValues(const WideString Section, Tntclasses::TTntStrings* Strings);
	virtual WideString __fastcall ReadString(const WideString Section, const WideString Ident, const WideString Default);
	void __fastcall Rename(const WideString FileName, bool Reload);
	void __fastcall SetStrings(Tntclasses::TTntStrings* List);
	virtual void __fastcall UpdateFile(void);
	virtual void __fastcall WriteString(const WideString Section, const WideString Ident, const WideString Value);
	__property bool CaseSensitive = {read=GetCaseSensitive, write=SetCaseSensitive, nodefault};
	
/* Hoisted overloads: */
	
public:
	inline void __fastcall  ReadSections(const WideString Section, Tntclasses::TTntStrings* Strings){ TTntCustomIniFile::ReadSections(Section, Strings); }
	
};


class DELPHICLASS TTntIniFile;
class PASCALIMPLEMENTATION TTntIniFile : public TTntCustomIniFile 
{
	typedef TTntCustomIniFile inherited;
	
private:
	Inifiles::TIniFile* FAnsiIniFile;
	
public:
	__fastcall virtual TTntIniFile(const WideString FileName);
	__fastcall virtual ~TTntIniFile(void);
	virtual WideString __fastcall ReadString(const WideString Section, const WideString Ident, const WideString Default);
	virtual void __fastcall WriteString(const WideString Section, const WideString Ident, const WideString Value);
	virtual void __fastcall ReadSection(const WideString Section, Tntclasses::TTntStrings* Strings);
	virtual void __fastcall ReadSections(Tntclasses::TTntStrings* Strings)/* overload */;
	virtual void __fastcall ReadSectionValues(const WideString Section, Tntclasses::TTntStrings* Strings);
	virtual void __fastcall EraseSection(const WideString Section);
	virtual void __fastcall DeleteKey(const WideString Section, const WideString Ident);
	virtual void __fastcall UpdateFile(void);
	
/* Hoisted overloads: */
	
public:
	inline void __fastcall  ReadSections(const WideString Section, Tntclasses::TTntStrings* Strings){ TTntCustomIniFile::ReadSections(Section, Strings); }
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Tntinifiles */
using namespace Tntinifiles;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// TntIniFiles
